#include <NewPing.h>

#define TRIGGER_PIN  9  // Arduino pin tied to trigger pin on the ultrasonic sensor.
#define ECHO_PIN     8  // Arduino pin tied to echo pin on the ultrasonic sensor.
#define MAX_DISTANCE 100 // Maximum distance we want to ping for (in centimeters). Maximum sensor distance is rated at 400-500cm.

int speed = 1000;
bool speed_direction = 0;

int direction = 1000;

int out_direction = 0;   //data to be outputed through serial, direction -100, 100
int out_speed = 0;       // speed data -100, 100

int distance = 100;

NewPing sonar(TRIGGER_PIN, ECHO_PIN, MAX_DISTANCE); // NewPing setup of pins and maximum distance.

void setup() {
  Serial.begin(115200);
  pinMode(3, INPUT); //steering input
  
  pinMode(5, INPUT); //throttle input
  
  pinMode(10, OUTPUT); // speed control
  
  pinMode(11, OUTPUT); //direction control
  pinMode(12, OUTPUT); //direction control

  pinMode(9, OUTPUT); //TRIGGER_PIN
  pinMode(8, INPUT); //ECHO_PIN
}

void loop() {
  speed = pulseIn(5, HIGH);
  direction = pulseIn(3, HIGH);
  
  out_direction = map(direction, 1000, 2000, 100, -100); //values that a servo inputs
  out_speed = map(speed, 1000, 2000, -100, 100);         //values that motor takes, neg-->backwards, pos-->forwards

  
  distance = sonar.ping_cm();
  if(distance == 0) {
    distance = 100;
  }
  
  Serial.print(out_direction + 8); //sends data to computer over serial, with tuning values
  Serial.print(" ");
  Serial.print(out_speed);
  Serial.print(" ");
  Serial.println(distance);       

  if(speed <= 1500) { //backwards
    speed_direction = 0;
    speed = map(speed, 1500, 1000, 0, 255);
  }

  else if(speed > 1500) { //forwards
    speed_direction = 1;
    speed = map(speed, 1500, 2000, 0, 255);
  }
  
  analogWrite(10, speed);             //motor speed control
  digitalWrite(11, speed_direction);  //direction pins
  digitalWrite(12, !speed_direction); //direction pins
}
